unit Buttons;
interface
uses Graph,BgiInst,GrMouse,VgiLo,TPCRT;
var MouseX,MouseY:integer;
Procedure MakeButton(Ax1,Ay1,Ax2,Ay2:integer;AText:String;ACode:Byte;
										 AKey:Word);
Function GetButton:Word;
implementation
Type    PGButton=^TGButton;
				TGButton=record
									x1,y1,x2,y2:integer;
									Key:Word;
									Code:byte;
									Selected:Boolean;
									Next:PGButton;
									Text:String;
								 end;
const ButtonList:PGButton=Nil;
Procedure DrawButton(B:TGButton);
var p:Pointer;
begin
 if SaveGraphSettings(P) then;
 SetLineStyle(0,0,1);
 SetColor(15);
 HideMouse;
 With b do
	begin
	 if Selected then SetFillStyle(SolidFill,Blue)
							 else SetFillStyle(SolidFill,Black);
	 Bar(x1,y1,x2,y2);
	 RectAngle(x1,y1,x2,y2);
	 OutTextXy(x1+2,y1+2,Text);
	end;
 ShowMouse;
 RestoreGraphSettings(P,True);
end;
Procedure MakeButton(Ax1,Ay1,Ax2,Ay2:integer;AText:String;ACode:Byte;
										 AKey:Word);
var P:PGButton;
begin
 New(P);
 With P^ do
	begin
	 x1:=AX1;
	 x2:=Ax2;
	 y1:=ay1;
	 y2:=ay2;
	 code:=Acode;
	 Text:=AText;
	 Key:=Akey;
	 Selected:=False;
	 Next:=ButtonList;
	end;
	DrawButton(P^);
	ButtonList:=P;
end;
Function GetButton:Word;
var z:byte;k:Word;
		p,q:PGButton;
		Pressed:boolean;
Function CheckKey:PGButton;
var P:PGButton;
	begin
	 CheckKey:=nil;
	 P:=ButtonList;
	 While P<>nil do
		begin
		 if P^.Key=k then begin CheckKey:=P;exit end;
		 P:=P^.next;
		end;
	end;
Function CheckXY:PGButton;
	var p:PGButton;
	begin
	 CheckXY:=nil;
	 P:=ButtonList;
	 While P<>nil do
		begin
		 if (P^.X1<=MouseX)and(P^.X2>=MouseX)and(P^.Y1<=MouseY)and(P^.Y2>=MouseY)
		 then begin CheckXY:=P;exit end;
		 P:=P^.next;
		end;
	end;
begin
 p:=nil;
 ReadMouse(MouseX,MouseY,z);
 if CheckKBd(k) then
	P := CheckKey;
	if (p=nil)and(z=1)then
	P:=CheckXY;
	GetButton := z;
	if p=nil then  exit ;
	P^.Selected:=True;
	GetButton := P^.Code;
	DrawButton (P^);
	q:=ButtonList;
	While q<>nil do
	 begin
		if (Q<>P)and Q^.Selected then begin Q^.Selected:=False;DrawButton(Q^) end;
		q:=Q^.Next;
	 end;
		Repeat ReadMouse(Mousex,MouseY,z) until z=0;
end;
end.