{***********************************************************************}
{*                       Vitus Graphic interfasce                      *}
{*                             Version 1.0                             *}
{*                 Copyright (C) by V.B.Wagner  , 1991                 *}
{*                            BGIInst.Pas                              *}
{*                   樠樨 䨪                    *}
{*                           CGA, EGA  VGA                            *}
{***********************************************************************}
unit bgiinst;
interface
uses graph;
Var GraphDriver,GraphMode:integer;
    GraphStringHeight:byte;
procedure initgraph;
procedure initcga;
procedure SetGraphMode(Mode:integer);
implementation
procedure InitGraph;
begin
 DetectGraph(GraphDriver,GraphMode);
 if GraphDriver=CGA then
  GraphMode:=CGaHi
 else
  GraphMode:=EgaHi;
 Graph.InitGraph(GraphDriver,GraphMode,'');
 GraphStringHeight:=(GetMaxY+1)div 25;
end;
procedure InitCGA;
begin
 GraphDriver:=CGA;
 GraphMode:=CGAHi;
 Graph.initGraph(GraphDriver,GraphMode,'');
 GraphStringHeight:=8;
end;
procedure SetGraphMode(Mode:integer);
begin
 Graph.SetGraphMode(Mode);
 GraphStringHeight:=(GetMaxY+1)div 25;
end;

var i:integer;
procedure CGADrv;external;
procedure EGAVGA;External;
{$L CGA.OBJ}
{$L EGA.obj}
begin
 DetectGraph(GraphDriver,GraphMode);
 if GraphDriver=-2 then
  begin
   Writeln('Graphic Card not found');
   halt;
  end;
  if (GraphDriver<>CGA)and(GraphDriver<>EGA)and(GraphDriver<>EGA64)and
     (GraphDriver<>EGAMono)and(GraphDriver<>VGA) then
  begin
   Writeln('Unsupported Graphic Card');
   halt
  end;
  i:=RegisterBGIDriver(@EgaVga);
  i:=RegisterBGIDriver(@CGADrv);
end.